"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.serveSettings = void 0;
exports.initSettingsFromCli = initSettingsFromCli;
exports.applySettings = applySettings;
const commander_1 = require("commander");
const helpers_1 = require("./helpers");
function initSettingsFromCli(cliSettings) {
    var _a, _b, _c, _d;
    const defaultServeSettings = {};
    const explicitServeSettings = {};
    for (const key in cliSettings) {
        if (Object.prototype.hasOwnProperty.call(cliSettings, key)) {
            if (commander_1.program.getOptionValueSource(key) === 'default') {
                defaultServeSettings[key] = cliSettings[key];
            }
            if (commander_1.program.getOptionValueSource(key) === 'cli') {
                explicitServeSettings[key] = cliSettings[key];
            }
        }
    }
    const fileBasedSettings = (_a = (0, helpers_1.getJSONFile)('fast-serve/config.json')) !== null && _a !== void 0 ? _a : {};
    fileBasedSettings.serve = (_b = fileBasedSettings.serve) !== null && _b !== void 0 ? _b : {};
    if (((_c = fileBasedSettings.cli) === null || _c === void 0 ? void 0 : _c.isLibraryComponent) != null) {
        fileBasedSettings.serve.isLibraryComponent = fileBasedSettings.cli.isLibraryComponent;
    }
    if (((_d = fileBasedSettings.cli) === null || _d === void 0 ? void 0 : _d.port) != null) {
        fileBasedSettings.serve.port = fileBasedSettings.cli.port;
    }
    if (cliSettings.isLibraryComponent || fileBasedSettings.serve.isLibraryComponent) {
        defaultServeSettings.port = 4320;
    }
    exports.serveSettings = {
        ...defaultServeSettings,
        ...fileBasedSettings.serve,
        ...explicitServeSettings,
    };
}
function applySettings(externalSettings) {
    exports.serveSettings = {
        ...externalSettings
    };
}
//# sourceMappingURL=settingsManager.js.map